<?php

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

class Util extends CComponent{
    
    public static $deli = "\\";
    public static $modelBaseClasses = array('CActiveRecord');
    public static $modelDenotingAttributes = array('username', 'title', 'name', 'alias', 'last_name', 'first_name', 'mail', 'id');
    
    public static function getAllModels(){
        $models = self::fetchModelsFromFiles();
        
        return $models;
    }
    
    public static function fetchModelsFromFiles(){
        $path = Yii::app()->getBasePath();
        
        $path.='/config/main.php';
        
        if(!file_exists($path))
            throw new CException("Main config not available! ".$path);
        
        $res = include($path);
        $imports = $res['import'];
        
        $models = array();
        
        foreach($imports as $import){
            $models = array_merge($models, self::fetchModelsFromDirectory($import));
        }
        
        return $models;
    }
    
    public static function fetchModelsFromDirectory($dir){
        $dir = Yii::getPathOfAlias($dir);
        
        $models = array();
        
        if(!is_dir($dir))
            return $models;
        
        $files = scandir($dir);
        foreach($files as $file){
            $new = self::isValidModel($dir.self::$deli.$file);
            
            if($new)
                $models[] = $new;
        }
        
        return $models;
    }
    
    public static function isValidModel($file){
        $parts = explode(".", $file);
        
        if($parts[sizeof($parts) - 1] != 'php')
            return false;
        
        $contents = file_get_contents($file);
        
        preg_match_all("/class ([a-zA-Z]*) extends ([a-zA-Z]*)/", $contents, $res);
        if(!$res)
            return false;
        
        //If we didn't match correctly - never mind, we'll junk them later :)
        $model      = @$res[1][0];
        $baseClass  = @$res[2][0];
   
        if(in_array($baseClass, self::$modelBaseClasses))
            return $model;

        return false;
    }
    
    public static function getDenotingAttribute($model){
        $attributes = array_keys($model->getAttributes());
        
        foreach(self::$modelDenotingAttributes as $attr){
            if(in_array($attr, $attributes))
                    return $attr;
        }
        return false;
    }
    
    public static function getTitle($instance){
        $attribute = self::getDenotingAttribute($instance);
        
        return $instance->{$attribute};
    }
    
    public static function getRelObjectTitle($instance){
        
        if($instance->alias != NULL)
            return $instance->alias;
        
        if($instance->model != NULL && $instance->foreign_key != NULL){
            $model = $instance->model;
            $related = $model::model()->findByPk($instance->foreign_key);

            if(!$related)
                return false;
            
            return self::getTitle($related);
        }
        
    }
    
    //$obj is either Aro or Aco
    public static function getPossibleAliases($obj){
        $rows = $obj->findAll('alias IS NOT NULL');
        
        $aliases = array();
        foreach($rows as $row){
            $aliases[$row->id] = $row->alias;
        }
        
        return $aliases;
    }
    
}
?>
