<?php
    $modelFieldId       = $htmlDialogId.'model';
    $foreignNameFieldId = $htmlDialogId.'_foreign_key_name';
    $foreignKeyFieldId  = $htmlDialogId.'_foreign_key';
            
    $labelFieldId         = $htmlDialogId.'label';   
?>

<table>
            
            <tr>
                <th><?php echo CHtml::activeLabel($model,'model'); ?></th>
                <td>
                    <?php 
                        //Fetch all Models and display them in a dropdown
                        $models = Util::getAllModels(); 
                        $this->widget('zii.widgets.jui.CJuiAutoComplete', array(
                            'name' => $modelFieldId,
                            'source'=> $models,
                            'htmlOptions'=>array(
                                'style'=>'height:20px;',
                                'id'   => $modelFieldId,
                            ),
                        ));
                     ?>

                </td>
            </tr>
            
             <tr>
                <th><?php echo CHtml::activeLabel($model,'foreign_key'); ?></th>
                <td>
                     <?php $this->widget('zii.widgets.jui.CJuiAutoComplete', array(
                            'name'=> $foreignNameFieldId,
                            'htmlOptions'=>array(
                                'style'=>'height:20px;',
                                'id' => $foreignNameFieldId
                            )
                        ));
                        
                        //We need the ID of the selected object somehow
                        echo CHtml::activeHiddenField($model, 'foreign_key', array('id' => $foreignKeyFieldId)); 
                     ?>
                </td>
            </tr>
        </table>

<?php
    //Now register some fancy stuff
    $cs = Yii::app()->getClientScript();
    
    //First one: we need tot modify the ajax-request in order to add the model to the second autocomplete
    $cs->registerScript(
        __CLASS__.$htmlDialogId.'#autoComplete', 
            "jQuery('#".$foreignNameFieldId."').autocomplete( 'option', 'source', generateAutoComplete('".$modelFieldId."'));"
    );
    
    //Second one: we have to save the ID of the selected object, if the user selects something
     $cs->registerScript(
        __CLASS__.$htmlDialogId.'#saveChoice', 
        "$( '#".$foreignNameFieldId."' ).bind( 'autocompleteselect', function(event, ui) {"
            ."document.getElementById('".$foreignKeyFieldId."').value = ui.item.id;"
            ."});");
    
?>

<script type='text/javascript'>
    
    function generateAutoComplete(field){
        var localField = field; 
        return autoCompleteObject;
        
      function autoCompleteObject( request, response ) {
        var url = "<?php echo CHtml::normalizeUrl(array("/acl/default/suggestObject")); ?>&model="+document.getElementById(localField).value;
        $.getJSON(url, request, function( data, status, xhr ) {
            response(data);
	});
      }
    }
    
    function performSelection<?php echo $htmlDialogId; ?>(){
        var model = document.getElementById('<?php echo $modelFieldId; ?>').value;
        var value = document.getElementById('<?php echo $foreignNameFieldId; ?>').value;
        var key = document.getElementById('<?php echo $foreignKeyFieldId; ?>').value;
        
        document.getElementById('<?php echo $labelFieldId; ?>').value = model+": "+value+" (#"+key+")";
        $('#<?php echo $htmlDialogId; ?>').dialog('close');
        
        return true;
    }
    
</script>