<?php

/**
 * AcoCollection Class File
 *
 * @author zeroByte <dispyfree@googlemail.com>
 * @copyright mine 
 * @license LGPLv2
 */

/**
 * AcoCollections represent bunches of Aco-objects associcated to one parent
 * This is the class you will use in your daily work
 */
class AcoCollection extends ACLObjectCollection
{
    
    /**
     * We have to overwrite the table as we don't want to operate on a tree of collections but on a tree of nodes
     */
    public function init() {
        $this->tree = new Tree(self::$acoTable, 'aco');
	parent::init();	
        
        $behavior = new CompositeBehavior('Aco', 'collection_id', array('parent_id' => 'parent_id', 'id' => 'collection_id'));
        $this->attachBehavior('composite', $behavior);
    }
    
    
    public function tableName(){
        return self::$acoCollectionTable;
    }
    
    /**
     * @return array relational rules.
     */
    public function relations()
    {
        // NOTE: you may need to adjust the relation name and the related
        // class name for the relations automatically generated below.
        return array(
            array(self::HAS_MANY, 'Aco', 'id')
        );
    }
    
    
    /**
     * Returns the static model of the specified AR class.
     * @param string $className active record class name.
     * @return AcoCollection the static model class
     */
    public static function model($className=__CLASS__)
    {
        return parent::model($className);
    }
} 

?>