<?php

/**
 * This is the model class for table "{{aco_aro}}".
 *
 * The followings are the available columns in table '{{aco_aro}}':
 * @property integer $id
 * @property integer $aco_id
 * @property integer $aro_id
 * @property integer $create
 * @property integer $read
 * @property integer $update
 * @property integer $delete
 */
class Permission extends CActiveRecord
{
    /**
     * Returns the static model of the specified AR class.
     * @param string $className active record class name.
     * @return Permission the static model class
     */
    public static function model($className=__CLASS__)
    {
        return parent::model($className);
    }

    /**
     * @return string the associated database table name
     */
    public function tableName()
    {
        return '{{aco_aro}}';
    }

    /**
     * @return array validation rules for model attributes.
     */
    public function rules()
    {
        // NOTE: you should only define rules for those attributes that
        // will receive user inputs.
        return array(
        );
    }

    /**
     * @return array relational rules.
     */
    public function relations()
    {
        // NOTE: you may need to adjust the relation name and the related
        // class name for the relations automatically generated below.
        return array(
            'aco' => array(self::BELONGS_TO, 'Aco', 'aco_id'),
        );
    }

    /**
     * @return array customized attribute labels (name=>label)
     */
    public function attributeLabels()
    {
        return array(
            'id' => 'ID',
            'aco_id' => 'Aco',
            'aro_id' => 'Aro',
            'create' => 'Create',
            'read' => 'Read',
            'update' => 'Update',
            'delete' => 'Delete',
        );
    }

} 

?>