<?php

class UpdateForm extends CFormModel{
    
    public $id;
    public $alias;
    
    public $model;  
    public $foreign_key_name;
    public $foreign_key;
    public $object;
    
    public  $parent_model_name;
    public  $parent_name;
    public  $parent_id;
    public  $parent;
    
    public  $obj = 'Aro';
    
    public function rules(){
        return array(
            array('id', 'safe'),
            array('alias', 'safe'),
            array('model', 'safe'),
            array('foreign_key', 'safe'),
            array('parent_id', 'safe')
        );
    }
    
    //Load additional values, as we are only given the basic things from ACL-Object CActiveRecord
    public function loadAdditionalValues(){
        
        $this->loadAssociatedData();
        $this->loadParentData();
        
    }
    
    protected function loadAssociatedData(){
        if($this->model != NULL && $this->foreign_key != NULL){
            $class = $this->model;
            $model = $class::model();
            $row = $model->findByPk($this->foreign_key);

            if(!$row)
                $this->addError('foreign_key', 'There is no corresponding row in the database');
            else{
                $this->foreign_key_name = Util::getTitle($row);
            }
        }
    }
    
    protected function loadParentData(){
        if($this->parent_id != NULL){
            //Now fetch related row of the parent node - if it exists
            $class = $this->obj;
            $model = $class::model();

            $row = $model->find('id = :parent_id', array(':parent_id' => $this->parent_id));
            //If there's no parent !!
            if(!$row){
                $this->addError('parent_id', 'There is no such parent in the database');
            }
            else{
                $this->parent = $row;
                //Ok there is such a parent. Does the parent have any relational record? ^^
                if($row->model != NULL && $row->foreign_key != NULL)
                    $this->parent_model_name = $row->model;
                    $this->loadAssociatedParentRecord($row);
            }
        }
    }
    
    protected function loadAssociatedParentRecord($obj){
        $class = $obj->model;
        $model = $class::model();
        $row = $model->findByPk($obj->foreign_key);
        
        //there's an invalid relational link
        if(!$row)
            $this->addError('foreign_key', 'The record the parent relates to doesn\'t exist');
        else{
            $this->parent_name = Util::getTitle($row);
        }
    }
}
?>
